## ros-indigo-find-object-2d 0.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(find_object_2d)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS 
             cv_bridge roscpp rospy sensor_msgs std_msgs image_transport genmsg message_filters pcl_ros tf
)

## Generate messages in the 'msg' folder
add_message_files(
   FILES
   ObjectsStamped.msg
)

## Generate added messages and services with any dependencies listed here
generate_messages(
   DEPENDENCIES
   std_msgs
   sensor_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  CATKIN_DEPENDS cv_bridge roscpp rospy sensor_msgs std_msgs image_transport message_filters pcl_ros tf
)

###########
## Build ##
###########
SET(PROJECT_VERSION “0.5.1”)
SET(PROJECT_PREFIX find_object)

STRING(REGEX MATCHALL "[0-9]" PROJECT_VERSION_PARTS "${PROJECT_VERSION}")
LIST(GET PROJECT_VERSION_PARTS 0 PROJECT_VERSION_MAJOR)
LIST(GET PROJECT_VERSION_PARTS 1 PROJECT_VERSION_MINOR)
LIST(GET PROJECT_VERSION_PARTS 2 PROJECT_VERSION_PATCH)

ADD_DEFINITIONS(-DPROJECT_PREFIX="${PROJECT_PREFIX}")
ADD_DEFINITIONS(-DPROJECT_VERSION="${PROJECT_VERSION}")

find_package(Qt4 COMPONENTS QtCore QtGui QtNetwork)
FIND_PACKAGE(OpenCV REQUIRED) # tested on 2.3.1

IF(OPENCV_NONFREE_FOUND)
  SET(NONFREE 1)
ELSE()
  SET(NONFREE 0)
ENDIF()
CONFIGURE_FILE(Version.h.in ${PROJECT_SOURCE_DIR}/include_x/${PROJECT_PREFIX}/Version.h)

### Qt Gui stuff ###
SET(headers_ui 
	./include_x/find_object/MainWindow.h
	./include_x/find_object/TcpServer.h
	./include_x/find_object/ObjWidget.h
	./include_x/find_object/Camera.h
	./include_x/find_object/FindObject.h
	./src_x/AddObjectDialog.h
	./src_x/ParametersToolBox.h
	./src_x/RectItem.h
	./src_x/CameraTcpServer.h
	./src/CameraROS.h
	./src/FindObjectROS.h
	./src_x/AboutDialog.h
	./src_x/utilite/UPlot.h
	./src_x/rtabmap/PdfPlot.h
	./src_x/ImageDropWidget.h
)

SET(uis
    ./src_x/ui/mainWindow.ui
    ./src_x/ui/addObjectDialog.ui
    ./src_x/ui/aboutDialog.ui
)

SET(qrc 
    ./src_x/resources.qrc
)

# generate rules for building source files from the resources
QT4_ADD_RESOURCES(srcs_qrc ${qrc})

#Generate .h files from the .ui files
QT4_WRAP_UI(moc_uis ${uis})

#This will generate moc_* for Qt
QT4_WRAP_CPP(moc_srcs ${headers_ui})
### Qt Gui stuff  end###


SET(SRC_FILES 
	./src_x/MainWindow.cpp
	./src_x/AddObjectDialog.cpp
	./src_x/KeypointItem.cpp
	./src_x/QtOpenCV.cpp
	./src_x/Camera.cpp
	./src_x/CameraTcpServer.cpp
	./src/CameraROS.cpp
	./src/FindObjectROS.cpp
	./src_x/ParametersToolBox.cpp
	./src_x/Settings.cpp
	./src_x/FindObject.cpp
	./src_x/ObjWidget.cpp
	./src_x/TcpServer.cpp
	./src_x/Vocabulary.cpp
	./src_x/RectItem.cpp
	./src_x/AboutDialog.cpp
	./src_x/JsonWriter.cpp
	./src_x/utilite/UPlot.cpp
	./src_x/utilite/UFile.cpp
	./src_x/utilite/UDirectory.cpp
	./src_x/utilite/UConversion.cpp
	./src_x/utilite/ULogger.cpp
	./src_x/rtabmap/PdfPlot.cpp
	./src_x/ImageDropWidget.cpp
	./src_x/json/jsoncpp.cpp
	${moc_srcs} 
	${moc_uis} 
	${srcs_qrc}
)

SET(INCLUDE_DIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/src_x
	${CMAKE_CURRENT_SOURCE_DIR}/include_x
	${CMAKE_CURRENT_BINARY_DIR} # for qt ui generated in binary dir
	${catkin_INCLUDE_DIRS}
)

INCLUDE(${QT_USE_FILE})
ADD_DEFINITIONS(-DQT_NO_KEYWORDS)

SET(LIBRARIES
    ${QT_LIBRARIES} 
    ${catkin_LIBRARIES}
)

#include files
INCLUDE_DIRECTORIES(${INCLUDE_DIRS})

add_executable(find_object_2d src/find_object_2d_node.cpp ${SRC_FILES})
target_link_libraries(find_object_2d ${LIBRARIES})
add_dependencies(find_object_2d find_object_2d_generate_messages_cpp)

add_executable(print_objects_detected src/print_objects_detected_node.cpp)
target_link_libraries(print_objects_detected ${LIBRARIES})
add_dependencies(print_objects_detected find_object_2d_generate_messages_cpp)

add_executable(tf_example src/tf_example_node.cpp)
target_link_libraries(tf_example ${LIBRARIES})
add_dependencies(tf_example find_object_2d_generate_messages_cpp)

#############
## Install ##
#############
## Mark executables and/or libraries for installation
install(TARGETS 
   find_object_2d 
   print_objects_detected 
   tf_example 
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
 )

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
   launch/find_object_2d_gui.launch
   launch/find_object_2d.launch
   launch/find_object_3d.launch
   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

=== src_x/CMakeLists.txt ===


### Qt Gui stuff ###
SET(headers_ui 
	../include/${PROJECT_PREFIX}/MainWindow.h
	../include/${PROJECT_PREFIX}/FindObject.h
	../include/${PROJECT_PREFIX}/Camera.h
	../include/${PROJECT_PREFIX}/TcpServer.h
	../include/${PROJECT_PREFIX}/ObjWidget.h
	./AddObjectDialog.h
	./CameraTcpServer.h
	./ParametersToolBox.h
	./AboutDialog.h
	./RectItem.h
	./ImageDropWidget.h
	./rtabmap/PdfPlot.h
	./utilite/UPlot.h
)

SET(uis
    ./ui/mainWindow.ui
    ./ui/addObjectDialog.ui
    ./ui/aboutDialog.ui
)

SET(qrc 
    ./resources.qrc
)

# generate rules for building source files from the resources
QT4_ADD_RESOURCES(srcs_qrc ${qrc})

#Generate .h files from the .ui files
QT4_WRAP_UI(moc_uis ${uis})

#This will generate moc_* for Qt
QT4_WRAP_CPP(moc_srcs ${headers_ui})
### Qt Gui stuff  end###

SET(SRC_FILES 
	./MainWindow.cpp
	./AddObjectDialog.cpp
	./KeypointItem.cpp
	./RectItem.cpp
	./QtOpenCV.cpp
	./Camera.cpp
	./CameraTcpServer.cpp
	./ParametersToolBox.cpp
	./Settings.cpp
	./ObjWidget.cpp
	./ImageDropWidget.cpp
	./FindObject.cpp
	./AboutDialog.cpp
	./TcpServer.cpp
	./Vocabulary.cpp
	./JsonWriter.cpp
	./utilite/ULogger.cpp
	./utilite/UPlot.cpp
	./utilite/UDirectory.cpp
	./utilite/UFile.cpp
	./utilite/UConversion.cpp
	./rtabmap/PdfPlot.cpp
	./json/jsoncpp.cpp
	${moc_srcs} 
	${moc_uis} 
	${srcs_qrc}
)

SET(INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../include
	${CMAKE_CURRENT_SOURCE_DIR}
	${OpenCV_INCLUDE_DIRS}
	${CMAKE_CURRENT_BINARY_DIR} # for qt ui generated in binary dir
)

INCLUDE(${QT_USE_FILE})

SET(LIBRARIES
    ${QT_LIBRARIES} 
    ${OpenCV_LIBS} 
)

#include files
INCLUDE_DIRECTORIES(${INCLUDE_DIRS})

# create a library from the source files
ADD_LIBRARY(find_object ${SRC_FILES})
# Linking with Qt libraries
TARGET_LINK_LIBRARIES(find_object ${LIBRARIES})

INSTALL(TARGETS find_object
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}" COMPONENT runtime
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}" COMPONENT devel
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}" COMPONENT devel)
        
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../include/ DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT devel FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)

=== debian/changelog ===
ros-indigo-find-object-2d (0.5.1-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Mon, 09 Mar 2015 15:30:15 -0000

=== debian/control ===
Source: ros-indigo-find-object-2d
Section: misc
Priority: extra
Maintainer: Mathieu Labbe <matlabbe@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-cv-bridge, ros-indigo-genmsg, ros-indigo-image-transport, ros-indigo-message-filters, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-tf
Homepage: http://find-object.googlecode.com
Standards-Version: 3.9.2

Package: ros-indigo-find-object-2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-cv-bridge, ros-indigo-image-transport, ros-indigo-message-filters, ros-indigo-pcl-ros, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs, ros-indigo-tf
Description: The find_object_2d package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-find-object-2d//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
